﻿//Created: 11/17/2014 by Dagradt
//Professions: Blacksmithing(600)/Engineering(600)
//Talents: 2003002
//Glyphs: None
//Revision: f542c7ac3854

using CommonBehaviors.Actions;
using Styx;
using Styx.Common;
using Styx.CommonBot.Routines;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

#region [Method] - Class Redundancy
using HKM = ElJefeSV.Core.Managers.Hotkey_Manager;
using R = ElJefeSV.Rotation.Rotation;
using U = ElJefeSV.Core.Unit;
using Styx.WoWInternals;
#endregion

namespace ElJefeSV
{
    public class Main : CombatRoutine
    {
        private static readonly Version version = new Version(0, 0, 1);
        public override string Name { get { return "ElJefeSV v" + version; } }
        public override WoWClass Class { get { return WoWClass.Hunter; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        #region [Method] - Implementations
        public override Composite PreCombatBuffBehavior { get { return new ActionRunCoroutine(ctx => R.preCombatBuffing()); } }
        public override Composite CombatBuffBehavior { get { return new ActionRunCoroutine(ctx => R.combatBuffing()); } }
        public override Composite CombatBehavior { get { return new ActionRunCoroutine(ctx => R.rotationSelector()); } }

        #region[Method] - Hidden Overrides
        public override void Initialize()
        {
            Logging.Write(Colors.GreenYellow, "Hello {0}", Me.SafeName);
            Logging.Write("");
            Logging.Write(Colors.GreenYellow, "For optimal Performance, please use: Enyo");
            Logging.Write("");
            Logging.Write(Colors.GreenYellow, "Current Version:");
            Logging.Write(Colors.GreenYellow, "-- Survival v" + version + " --");
            Logging.Write(Colors.GreenYellow, "-- by papagal --");
            Logging.Write(Colors.GreenYellow, "-- A Survival Hunter Combat Routine --");
            HKM.registerHotKeys();
        }
        public override bool WantButton { get { return true; } }
        public override void OnButtonPress()
        {
            Logging.Write(Colors.DarkOrange, "Configuration opened!");
            //new Settings_Form().ShowDialog();
        }
        public override void ShutDown() { HKM.removeHotkeys(); }
        #endregion

        #region [Method] - Pulse
        public override void Pulse()
        {
            if (!StyxWoW.IsInWorld || Me == null || !Me.IsValid || !Me.IsAlive)
                return;
            if (!Me.Combat)
                return;
            U.Cache();
            U.enemyAnnex(40f);//~> Max range of AoE spells
            U.UpdateEnemyList(40f);
        }
        #endregion

        #endregion
    }
}