﻿using Styx;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

#region [Method] - Class Redundancy
using HKM = ElJefeSV.Core.Managers.Hotkey_Manager;
using S = ElJefeSV.Core.Spell;
using SB = ElJefeSV.Core.Helpers.Spell_Book;
using U = ElJefeSV.Core.Unit;
using L = ElJefeSV.Core.Utilities.Log;
using Styx.CommonBot;
#endregion

namespace ElJefeSV.Rotation
{
    class Rotation
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        private static WoWUnit currentTarget { get { return StyxWoW.Me.CurrentTarget; } }

        #region [Method] - Precombat Buffing
        public static async Task<bool> preCombatBuffing()
        {
            if (Me.Combat || !Me.IsAlive || (Me.Mounted || Me.OnTaxi))
                return true;
            return await S.Buff(SB.auraTrapLauncher, !U.auraExists(Me, SB.auraTrapLauncher));
        }
        #endregion

        #region [Method] - Combat Buffing
        public static async Task<bool> combatBuffing()
        {
            if (!Me.IsAlive || (!Me.GotTarget || !currentTarget.IsAlive) || (Me.Mounted || Me.OnTaxi))
                return true;
            if (!Me.IsAutoAttacking) { Lua.DoString("StartAttack()"); return true; }
            return await S.Buff(SB.auraTrapLauncher, !U.auraExists(Me, SB.auraTrapLauncher));
        }
        #endregion

        #region [Method] - Combat Rotation

        #region [Method] - Single Target
        public static async Task<bool> Master()
        {
//            L.combatLog("Single target.");
            WoWUnit dotTarget;
            dotTarget = U.GetEnemies().FirstOrDefault(u => Me.IsSafelyFacing(u) && U.auraTimeLeft(u, SB.auraSerpentSting) < 2000);

            if (await S.Cast(SB.spellBlackArrow, !S.onCooldown(SB.spellBlackArrow))) return true;
            if (await S.Cast(SB.spellArcaneShot, !U.auraExists(currentTarget, SB.auraSerpentSting))) return true;
            if (await S.Cast(SB.spellExplosiveShot, Me.CurrentFocus >= 15 || (U.auraExists(Me, SB.auraLNL, true) || S.cooldownTimeLeft(SB.spellBlackArrow) < SpellManager.GlobalCooldownLeft.TotalMilliseconds))) return true;
            if (await S.Cast(SB.spellCrows, Me.CurrentFocus >= 30)) return true;
            if (await S.Cast(SB.spellGlaiveToss, Me.CurrentFocus >= 15)) return true;
            if (await S.Drop(SB.spellExplosiveTrap, !U.auraExists(currentTarget, SB.spellExplosiveTrap))) return true;
            if (U.activeEnemies(Me.Location, 40f).Count() > 1 && U.activeEnemies(Me.Location, 40f).Count() < 4)
            {
                if (await S.Dot(SB.spellArcaneShot, dotTarget, dotTarget != null && dotTarget.Location != currentTarget.Location)) return true;
            }
            if (U.activeEnemies(Me.Location, 40f).Count() > 3)
            {
                if (await S.Cast(SB.spellMultiShot, Me.CurrentFocus > Me.MaxFocus - U.luaGetRegen() * 2)) return true;
            }
            else
            {
                if (await S.Cast(SB.spellArcaneShot, Me.CurrentFocus > Me.MaxFocus - U.luaGetRegen() * 2)) return true;
            }
            if (await S.Cast(SB.spellCobraShot, Me.CurrentFocus + 14 + U.luaGetRegen() * 3 < Me.MaxFocus)) return true;
            return true;
        }

        #endregion

        #region [Method] - Rotation Selector
        public static async Task<bool> rotationSelector()
        {
            if (!Me.IsAlive || (!Me.GotTarget || !currentTarget.IsAlive) || (Me.Mounted || Me.OnTaxi))
                return true;
            else return await Master();
        }
        #endregion

        #endregion
    }
}